#!/usr/bin/python

apmfile = "/proc/apm"

def beep(style, *args):
	import os
	beepcmd = "beep"
	presets = {
		"plug in": "-f 880 -l 70 -n -f 1200 -l 70",
		"unplug" : "-f 880 -l 70 -n -f 600 -l 70",
	}
	if presets.has_key(style):
		cmd = beepcmd + " " + presets[style]
		os.system(cmd)
		return
	else:
		if style == "percent":
			px = args[0]
			if px < 0: px = 100.0
			px = px / 100.0
			hi = 2000
			lo = 500
			med = lo + int(px * (hi-lo))
			cmd = beepcmd + " -f %s -l 40 -n -f %s -l 70 -n -f %s -l 30" % (hi, med, lo)
			#print 'beep:px "%s"' % (cmd)
			os.system(cmd)
			return
		else:
			raise ValueError, "Invalid style '%s'" % (style)

def read_battfile():
	fp = open(apmfile, "rb")
	text = fp.readline()
	fp.close()
	apm = text.split()
	plugged_in = int(apm[3], 16)
	percent = float(apm[6][:-1])
	if percent < 0: percent = 100.0
	return plugged_in, percent

def run(args):
	import time
	done = 0
	was_plugged_in = 0
	while not done:
		delay = 0
		is_plugged_in, percent = read_battfile()
		if is_plugged_in != was_plugged_in:
			beep(is_plugged_in and "plug in" or "unplug")
			delay = 1.0
		if not delay:
			delay = 1.0
			if not is_plugged_in:
				beep("percent", percent)
				if percent > 75: delay = percent / 2.0
				elif percent > 50: delay = percent / 4.0
				elif percent > 25: delay = percent / 8.0
				else: delay = percent / 10.0

		was_plugged_in = is_plugged_in
		#print "delay: %s(%s)" % (type(delay), delay)
		if is_plugged_in:
			time.sleep(delay)
			continue
		else:
			so_far = 0
			while so_far < delay:
				time.sleep(1.0)
				so_far += 1.0
				is_plugged_in, percent = read_battfile()
				if is_plugged_in:
					beep(is_plugged_in and "plug in" or "unplug")
					delay = 0
					was_plugged_in = is_plugged_in

if __name__ == "__main__":
	import sys
	run(sys.argv[1:])
